/*
    artifact generator: C:\My\wizzi\v5\apps\node_modules\wizzi-js\lib\artifacts\js\module\gen\main.js
    primary source IttfDocument: c:\my\wizzi\v5\apps\wizzi-tools-next\src\ittf\lib\wizzifiers\jsparser\babel\wizzifier.js.ittf
    utc time: Wed, 20 Jun 2018 04:00:17 GMT
*/
'use strict';
var util = require('util');
var path = require('path');
var file = require('wizzi-utils').file;
var verify = require('wizzi-utils').verify;
var parser = require("@babel/parser");
var ittfwriter = require("../../../util/ittfwriter");
var cleanBabel = require('./cleanBabel');
var format = function(parent, ast, options) {
    if (!ast) {
        throw new Error('missing ast. parent is: ' + util.inspect(parent, { depth: 2 }));
    }
    if (parent === null) {
        if (options.starter) {
            options.starter = false;
        }
        else if (options.returnText) {
            // ok
        }
        else {
            showstack(options);
            throw new Error('parent is null.' + util.inspect(ast, 4));
        }
    }
    if (options.verbose) {
        console.log('ast.type', ast.type);
    }
    var formatter = format[ast.type];
    if (formatter) {
        options.stack.push(ast);
        var result = formatter(parent, ast, options);
        options.stack.pop();
        return result;
    }
    else {
        throw new Error('no formatter for type: ' + ast.type);
    }
};
var formatText = function(parent, ast, options, node) {
    var saveReturnText = options.returnText;
    options.returnText = true;
    if (node) {
        options.formatTextNodes.push(node);
    }
    var value = format(parent, ast, options);
    if (node) {
        options.formatTextNodes.pop();
    }
    options.returnText = saveReturnText;
    return value;
};
format.File = function(parent, node, options) {
    console.log('node File -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = parent;
    // process node property program and append ittfNode to `ret`
    if (node.program) {
        if (!node.program.type) {
            throw 'Node program has no type';
        }
        format(ret, node.program, options);
    }
    if (node.comments) {
        var count = 0, temp;
        var i, i_items=node.comments, i_len=node.comments.length, item;
        for (i=0; i<i_len; i++) {
            item = node.comments[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
};
format.Program = function(parent, node, options) {
    console.log('node Program -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = parent;
    console.log('node.sourceType', node.sourceType, 'string');
    ret.children.push({
        tag: 'sourceType', 
        name: node.sourceType, 
        children: [
            
        ]
    });
    if (node.body) {
        var count = 0, temp;
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 10) {
                    break;
                }
            */
        }
    }
    if (node.directives) {
        var count = 0, temp;
        var i, i_items=node.directives, i_len=node.directives.length, item;
        for (i=0; i<i_len; i++) {
            item = node.directives[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > Directive) {
                    break;
                }
            */
        }
    }
};
format.Identifier = function(parent, node, options) {
    console.log('node Identifier -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'ident', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    console.log('t/name.node.name', node.name, 'string');
    if (typeof node.name !== 'undefined') {
        ret.name = node.name.toString();
    }
    console.log('t/name ret', ret);
    // An identifier. Note that an identifier may be an expression or a destructuring pattern.
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.PrivateName = function(parent, node, options) {
    console.log('node PrivateName -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.Identifier) {
        if (!node.Identifier.type) {
            throw 'Node Identifier has no type';
        }
        var tempIdentifier = {
            children: [
                
            ]
        };
        format(tempIdentifier, node.Identifier, options);
        /**
            if (tempIdentifier .children.length > 0) {
                throw 'node.Identifier must result zero node, returned: ' + tempIdentifier.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempIdentifier.children.length > 0) {
            appto.name = tempIdentifier.children[0].name;
        }
        else {
            appto.name = tempIdentifier.name;
        }
    }
    // A Private Name Identifier.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.RegExpLiteral = function(parent, node, options) {
    console.log('node RegExpLiteral -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    console.log('t/name.node.pattern', node.pattern, 'string');
    if (typeof node.pattern !== 'undefined') {
        ret.name = node.pattern.toString();
    }
    console.log('t/name ret', ret);
    var p_flags = {
        children: [
            
        ]
    };
    if (node.flags) {
        if (!node.flags.type) {
            throw 'Node flags has no type';
        }
        format(p_flags, node.flags, options);
        p_flags.tag = 'flags';
        ret.children.push(p_flags);
        if (p_flags.children.length == 1) {
            if (p_flags.children[0].textified) {
                p_flags.textified = p_flags.children[0].textified;
            }
            if (p_flags.children[0].isText) {
                p_flags.isText = true;
                p_flags.name = p_flags.children[0].name;
                p_flags.children = [];
                console.log('*** f_p_tag', 'flags', p_flags.children.length, p_flags.children.length == 1 && p_flags.children[0].isText, ret);
            }
        }
    }
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.NullLiteral = function(parent, node, options) {
    console.log('node NullLiteral -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    ret.name = 'null';
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.StringLiteral = function(parent, node, options) {
    console.log('node StringLiteral -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    ret.name = node.extra.raw;
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.BooleanLiteral = function(parent, node, options) {
    console.log('node BooleanLiteral -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    console.log('t/name.node.value', node.value, 'string');
    if (typeof node.value !== 'undefined') {
        ret.name = node.value.toString();
    }
    console.log('t/name ret', ret);
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.NumericLiteral = function(parent, node, options) {
    console.log('node NumericLiteral -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'literal', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    console.log('t/name.node.value', node.value, 'string');
    if (typeof node.value !== 'undefined') {
        ret.name = node.value.toString();
    }
    console.log('t/name ret', ret);
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.Function = function(parent, node, options) {
    console.log('node Function -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'function', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A function [declaration](#functiondeclaration) or [expression](#functionexpression).
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type';
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // Embed an array of nodes in a new tag
    if (node.params && node.params.length > 0) {
        var tempparams = {
            tag: 'params', 
            children: [
                
            ]
        };
        var i, i_items=node.params, i_len=node.params.length, item;
        for (i=0; i<i_len; i++) {
            item = node.params[i];
            format(tempparams, item, options);
        }
        ret.children.push(tempparams);
    }
    // [ Pattern ]
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    console.log('node.generator', node.generator);
    if (!!node.generator == true) {
        ret.children.push({
            tag: 'generator', 
            children: [
                
            ]
        });
    }
    console.log('node.async', node.async);
    if (!!node.async == true) {
        ret.children.push({
            tag: 'async', 
            children: [
                
            ]
        });
    }
    replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param');
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ExpressionStatement = function(parent, node, options) {
    console.log('node ExpressionStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'stm', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An expression statement, i.e., a statement consisting of a single expression.
    // process node property expression and append ittfNode to `ret`
    if (node.expression) {
        if (!node.expression.type) {
            throw 'Node expression has no type';
        }
        format(ret, node.expression, options);
    }
    replaceWithSingleChild(ret, 'set');
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.BlockStatement = function(parent, node, options) {
    console.log('node BlockStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = parent;
    if (node.body) {
        var count = 0, temp;
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > body) {
                    break;
                }
            */
        }
    }
    if (node.directives) {
        var count = 0, temp;
        var i, i_items=node.directives, i_len=node.directives.length, item;
        for (i=0; i<i_len; i++) {
            item = node.directives[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // A block statement, i.e., a sequence of statements surrounded by braces.
};
format.EmptyStatement = function(parent, node, options) {
    console.log('node EmptyStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An empty statement, i.e., a solitary semicolon.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.DebuggerStatement = function(parent, node, options) {
    console.log('node DebuggerStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'debugger', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `debugger` statement.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.WithStatement = function(parent, node, options) {
    console.log('node WithStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'with', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property object and append ittfNode to `ret`
    if (node.object) {
        if (!node.object.type) {
            throw 'Node object has no type';
        }
        format(ret, node.object, options);
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    // A `with` statement.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ReturnStatement = function(parent, node, options) {
    console.log('node ReturnStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'return', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(ret, node.argument, options);
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified) {
            var c1 = ret.children[0].textified;
            ret.name = c1;
            // TODO This is ok for VariableDeclaration/VariableDeclarator
            // But could have collaterals ?
            ret.textified = ret.name;
        }
        if (ret.children[0].isText) {
            var c1 = ret.children[0].name;
            ret.name = c1;
            ret.isText = true;
            ret.textified = ret.name;
            ret.children = [];
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.LabeledStatement = function(parent, node, options) {
    console.log('node LabeledStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'label', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.label) {
        if (!node.label.type) {
            throw 'Node label has no type';
        }
        var templabel = {
            children: [
                
            ]
        };
        format(templabel, node.label, options);
        /**
            if (templabel .children.length > 0) {
                throw 'node.label must result zero node, returned: ' + templabel.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templabel.children.length > 0) {
            appto.name = templabel.children[0].name;
        }
        else {
            appto.name = templabel.name;
        }
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    // A labeled statement, i.e., a statement prefixed by a `break`/`continue` label.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.BreakStatement = function(parent, node, options) {
    console.log('node BreakStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'break', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.label) {
        if (!node.label.type) {
            throw 'Node label has no type';
        }
        var templabel = {
            children: [
                
            ]
        };
        format(templabel, node.label, options);
        /**
            if (templabel .children.length > 0) {
                throw 'node.label must result zero node, returned: ' + templabel.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templabel.children.length > 0) {
            appto.name = templabel.children[0].name;
        }
        else {
            appto.name = templabel.name;
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ContinueStatement = function(parent, node, options) {
    console.log('node ContinueStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'continue', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.label) {
        if (!node.label.type) {
            throw 'Node label has no type';
        }
        var templabel = {
            children: [
                
            ]
        };
        format(templabel, node.label, options);
        /**
            if (templabel .children.length > 0) {
                throw 'node.label must result zero node, returned: ' + templabel.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templabel.children.length > 0) {
            appto.name = templabel.children[0].name;
        }
        else {
            appto.name = templabel.name;
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.IfStatement = function(parent, node, options) {
    console.log('node IfStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'if', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_test = {
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type';
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
                console.log('*** f_p_tag', 'test', p_test.children.length, p_test.children.length == 1 && p_test.children[0].isText, ret);
            }
        }
    }
    var p_consequent = {
        children: [
            
        ]
    };
    if (node.consequent) {
        if (!node.consequent.type) {
            throw 'Node consequent has no type';
        }
        format(p_consequent, node.consequent, options);
        p_consequent.tag = 'then';
        ret.children.push(p_consequent);
        if (p_consequent.children.length == 1) {
            if (p_consequent.children[0].textified) {
                p_consequent.textified = p_consequent.children[0].textified;
            }
            if (p_consequent.children[0].isText) {
                p_consequent.isText = true;
                p_consequent.name = p_consequent.children[0].name;
                p_consequent.children = [];
                console.log('*** f_p_tag', 'consequent', p_consequent.children.length, p_consequent.children.length == 1 && p_consequent.children[0].isText, ret);
            }
        }
    }
    var p_alternate = {
        children: [
            
        ]
    };
    if (node.alternate) {
        if (!node.alternate.type) {
            throw 'Node alternate has no type';
        }
        format(p_alternate, node.alternate, options);
        p_alternate.tag = 'else';
        ret.children.push(p_alternate);
        if (p_alternate.children.length == 1) {
            if (p_alternate.children[0].textified) {
                p_alternate.textified = p_alternate.children[0].textified;
            }
            if (p_alternate.children[0].isText) {
                p_alternate.isText = true;
                p_alternate.name = p_alternate.children[0].name;
                p_alternate.children = [];
                console.log('*** f_p_tag', 'alternate', p_alternate.children.length, p_alternate.children.length == 1 && p_alternate.children[0].isText, ret);
            }
        }
    }
    setNameFromChildByTag(ret, 'test', true);
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.SwitchStatement = function(parent, node, options) {
    console.log('node SwitchStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'switch', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property discriminant and append ittfNode to `ret`
    if (node.discriminant) {
        if (!node.discriminant.type) {
            throw 'Node discriminant has no type';
        }
        format(ret, node.discriminant, options);
    }
    if (node.cases) {
        var count = 0, temp;
        var i, i_items=node.cases, i_len=node.cases.length, item;
        for (i=0; i<i_len; i++) {
            item = node.cases[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // A `switch` statement.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.SwitchCase = function(parent, node, options) {
    console.log('node SwitchCase -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'case', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property test and append ittfNode to `ret`
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type';
        }
        format(ret, node.test, options);
    }
    if (node.consequent) {
        var count = 0, temp;
        var i, i_items=node.consequent, i_len=node.consequent.length, item;
        for (i=0; i<i_len; i++) {
            item = node.consequent[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // A `case` (if `test` is an `Expression`) or `default` (if `test === null`) clause in the body of a `switch` statement.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ThrowStatement = function(parent, node, options) {
    console.log('node ThrowStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'throw', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(ret, node.argument, options);
    }
    // A `throw` statement.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.TryStatement = function(parent, node, options) {
    console.log('node TryStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'try', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property block and append ittfNode to `ret`
    if (node.block) {
        if (!node.block.type) {
            throw 'Node block has no type';
        }
        format(ret, node.block, options);
    }
    // process node property handler and append ittfNode to `ret`
    if (node.handler) {
        if (!node.handler.type) {
            throw 'Node handler has no type';
        }
        format(ret, node.handler, options);
    }
    // process node property finalizer and append ittfNode to `ret`
    if (node.finalizer) {
        if (!node.finalizer.type) {
            throw 'Node finalizer has no type';
        }
        format(ret, node.finalizer, options);
    }
    // A `try` statement. If `handler` is `null` then `finalizer` must be a `BlockStatement`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.CatchClause = function(parent, node, options) {
    console.log('node CatchClause -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'catch', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `catch` clause following a `try` block.
    var p_param = {
        children: [
            
        ]
    };
    if (node.param) {
        if (!node.param.type) {
            throw 'Node param has no type';
        }
        format(p_param, node.param, options);
        p_param.tag = 'Pattern | null';
        ret.children.push(p_param);
        if (p_param.children.length == 1) {
            if (p_param.children[0].textified) {
                p_param.textified = p_param.children[0].textified;
            }
            if (p_param.children[0].isText) {
                p_param.isText = true;
                p_param.name = p_param.children[0].name;
                p_param.children = [];
                console.log('*** f_p_tag', 'param', p_param.children.length, p_param.children.length == 1 && p_param.children[0].isText, ret);
            }
        }
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified) {
            var c1 = ret.children[0].textified;
            ret.name = c1;
            // TODO This is ok for VariableDeclaration/VariableDeclarator
            // But could have collaterals ?
            ret.textified = ret.name;
        }
        if (ret.children[0].isText) {
            var c1 = ret.children[0].name;
            ret.name = c1;
            ret.isText = true;
            ret.textified = ret.name;
            ret.children = [];
        }
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.WhileStatement = function(parent, node, options) {
    console.log('node WhileStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'while', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_test = {
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type';
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
                console.log('*** f_p_tag', 'test', p_test.children.length, p_test.children.length == 1 && p_test.children[0].isText, ret);
            }
        }
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified) {
            var c1 = ret.children[0].textified;
            ret.name = c1;
            // TODO This is ok for VariableDeclaration/VariableDeclarator
            // But could have collaterals ?
            ret.textified = ret.name;
        }
        if (ret.children[0].isText) {
            var c1 = ret.children[0].name;
            ret.name = c1;
            ret.isText = true;
            ret.textified = ret.name;
            ret.children = [];
        }
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.DoWhileStatement = function(parent, node, options) {
    console.log('node DoWhileStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'do', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_test = {
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type';
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
                console.log('*** f_p_tag', 'test', p_test.children.length, p_test.children.length == 1 && p_test.children[0].isText, ret);
            }
        }
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified) {
            var c1 = ret.children[0].textified;
            ret.name = c1;
            // TODO This is ok for VariableDeclaration/VariableDeclarator
            // But could have collaterals ?
            ret.textified = ret.name;
        }
        if (ret.children[0].isText) {
            var c1 = ret.children[0].name;
            ret.name = c1;
            ret.isText = true;
            ret.textified = ret.name;
            ret.children = [];
        }
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ForStatement = function(parent, node, options) {
    console.log('node ForStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'for', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_init = {
        children: [
            
        ]
    };
    if (node.init) {
        if (!node.init.type) {
            throw 'Node init has no type';
        }
        format(p_init, node.init, options);
        p_init.tag = 'init';
        ret.children.push(p_init);
        if (p_init.children.length == 1) {
            if (p_init.children[0].textified) {
                p_init.textified = p_init.children[0].textified;
            }
            if (p_init.children[0].isText) {
                p_init.isText = true;
                p_init.name = p_init.children[0].name;
                p_init.children = [];
                console.log('*** f_p_tag', 'init', p_init.children.length, p_init.children.length == 1 && p_init.children[0].isText, ret);
            }
        }
    }
    var p_test = {
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type';
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
                console.log('*** f_p_tag', 'test', p_test.children.length, p_test.children.length == 1 && p_test.children[0].isText, ret);
            }
        }
    }
    var p_update = {
        children: [
            
        ]
    };
    if (node.update) {
        if (!node.update.type) {
            throw 'Node update has no type';
        }
        format(p_update, node.update, options);
        p_update.tag = 'update';
        ret.children.push(p_update);
        if (p_update.children.length == 1) {
            if (p_update.children[0].textified) {
                p_update.textified = p_update.children[0].textified;
            }
            if (p_update.children[0].isText) {
                p_update.isText = true;
                p_update.name = p_update.children[0].name;
                p_update.children = [];
                console.log('*** f_p_tag', 'update', p_update.children.length, p_update.children.length == 1 && p_update.children[0].isText, ret);
            }
        }
    }
    var c1 = p_init.isText ? p_init.name : '';
    var c2 = p_test.isText ? p_test.name : '';
    var c3 = p_update.isText ? p_update.name : '';
    ret.name = c1 + '; ' + c2 + '; ' + c3;
    removeChildByTag(ret, 'init');
    removeChildByTag(ret, 'test');
    removeChildByTag(ret, 'update');
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ForInStatement = function(parent, node, options) {
    console.log('node ForInStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'for', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_left = {
        children: [
            
        ]
    };
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type';
        }
        format(p_left, node.left, options);
        p_left.tag = 'left';
        ret.children.push(p_left);
        if (p_left.children.length == 1) {
            if (p_left.children[0].textified) {
                p_left.textified = p_left.children[0].textified;
            }
            if (p_left.children[0].isText) {
                p_left.isText = true;
                p_left.name = p_left.children[0].name;
                p_left.children = [];
                console.log('*** f_p_tag', 'left', p_left.children.length, p_left.children.length == 1 && p_left.children[0].isText, ret);
            }
        }
    }
    var p_right = {
        children: [
            
        ]
    };
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type';
        }
        format(p_right, node.right, options);
        p_right.tag = 'right';
        ret.children.push(p_right);
        if (p_right.children.length == 1) {
            if (p_right.children[0].textified) {
                p_right.textified = p_right.children[0].textified;
            }
            if (p_right.children[0].isText) {
                p_right.isText = true;
                p_right.name = p_right.children[0].name;
                p_right.children = [];
                console.log('*** f_p_tag', 'right', p_right.children.length, p_right.children.length == 1 && p_right.children[0].isText, ret);
            }
        }
    }
    if (isChildrenCount(ret, 2)) {
        if (ret.children[0].textified && ret.children[1].textified) {
            var c1 = ret.children[0].textified;
            var c2 = ret.children[1].textified;
            ret.name = c1 + ' in ' + c2;
        }
        if (ret.children[0].isText && ret.children[1].isText) {
            var c1 = ret.children[0].name;
            var c2 = ret.children[1].name;
            ret.name = c1 + ' in ' + c2;
            ret.isText = true;
            ret.children = [];
        }
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ForOfStatement = function(parent, node, options) {
    console.log('node ForOfStatement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'for', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_left = {
        children: [
            
        ]
    };
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type';
        }
        format(p_left, node.left, options);
        p_left.tag = 'left';
        ret.children.push(p_left);
        if (p_left.children.length == 1) {
            if (p_left.children[0].textified) {
                p_left.textified = p_left.children[0].textified;
            }
            if (p_left.children[0].isText) {
                p_left.isText = true;
                p_left.name = p_left.children[0].name;
                p_left.children = [];
                console.log('*** f_p_tag', 'left', p_left.children.length, p_left.children.length == 1 && p_left.children[0].isText, ret);
            }
        }
    }
    var p_right = {
        children: [
            
        ]
    };
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type';
        }
        format(p_right, node.right, options);
        p_right.tag = 'right';
        ret.children.push(p_right);
        if (p_right.children.length == 1) {
            if (p_right.children[0].textified) {
                p_right.textified = p_right.children[0].textified;
            }
            if (p_right.children[0].isText) {
                p_right.isText = true;
                p_right.name = p_right.children[0].name;
                p_right.children = [];
                console.log('*** f_p_tag', 'right', p_right.children.length, p_right.children.length == 1 && p_right.children[0].isText, ret);
            }
        }
    }
    if (isChildrenCount(ret, 2)) {
        if (ret.children[0].textified && ret.children[1].textified) {
            var c1 = ret.children[0].textified;
            var c2 = ret.children[1].textified;
            ret.name = c1 + ' of ' + c2;
        }
        if (ret.children[0].isText && ret.children[1].isText) {
            var c1 = ret.children[0].name;
            var c2 = ret.children[1].name;
            ret.name = c1 + ' of ' + c2;
            ret.isText = true;
            ret.children = [];
        }
    }
    ret.children = [];
    console.log('node.await', node.await);
    if (!!node.await == true) {
        ret.children.push({
            tag: 'await', 
            children: [
                
            ]
        });
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.FunctionDeclaration = function(parent, node, options) {
    console.log('node FunctionDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'function', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A function [declaration](#functiondeclaration) or [expression](#functionexpression).
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type';
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // Embed an array of nodes in a new tag
    if (node.params && node.params.length > 0) {
        var tempparams = {
            tag: 'params', 
            children: [
                
            ]
        };
        var i, i_items=node.params, i_len=node.params.length, item;
        for (i=0; i<i_len; i++) {
            item = node.params[i];
            format(tempparams, item, options);
        }
        ret.children.push(tempparams);
    }
    replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param');
    console.log('node.generator', node.generator);
    if (!!node.generator == true) {
        ret.children.push({
            tag: 'generator', 
            children: [
                
            ]
        });
    }
    console.log('node.async', node.async);
    if (!!node.async == true) {
        ret.children.push({
            tag: 'async', 
            children: [
                
            ]
        });
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.VariableDeclaration = function(parent, node, options) {
    console.log('node VariableDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // enum "var" | "let" | "const"
    if (node.declarations) {
        var count = 0, temp;
        var i, i_items=node.declarations, i_len=node.declarations.length, item;
        for (i=0; i<i_len; i++) {
            item = node.declarations[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified) {
            var c1 = ret.children[0].textified;
            ret.name = c1;
            // TODO This is ok for VariableDeclaration/VariableDeclarator
            // But could have collaterals ?
            ret.textified = ret.name;
        }
        if (ret.children[0].isText) {
            var c1 = ret.children[0].name;
            ret.name = c1;
            ret.isText = true;
            ret.textified = ret.name;
            ret.children = [];
        }
    }
    console.log('==================== VariableDeclaration', ret);
    if (ret.children.length == 1 && ret.children[0].children.length == 1) {
        ret.name = ret.children[0].name;
        ret.children[0] = ret.children[0].children[0];
        ret.textified = node.kind + ' ' + ret.name;
    }
    else if (ret.children.length > 1) {
        var sb = [];
        var i, i_items=ret.children, i_len=ret.children.length, item;
        for (i=0; i<i_len; i++) {
            item = ret.children[i];
            if (item.textified) {
                sb.push(item.textified);
            }
            else {
                sb = null;
                break;
            }
        }
        if (sb) {
            ret.textified = sb.join(', ');
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.VariableDeclarator = function(parent, node, options) {
    console.log('node VariableDeclarator -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'decl', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_id = {
        children: [
            
        ]
    };
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type';
        }
        format(p_id, node.id, options);
        p_id.tag = 'id';
        ret.children.push(p_id);
        if (p_id.children.length == 1) {
            if (p_id.children[0].textified) {
                p_id.textified = p_id.children[0].textified;
            }
            if (p_id.children[0].isText) {
                p_id.isText = true;
                p_id.name = p_id.children[0].name;
                p_id.children = [];
                console.log('*** f_p_tag', 'id', p_id.children.length, p_id.children.length == 1 && p_id.children[0].isText, ret);
            }
        }
    }
    // process node property init and append ittfNode to `ret`
    if (node.init) {
        if (!node.init.type) {
            throw 'Node init has no type';
        }
        format(ret, node.init, options);
    }
    // A variable declarator.
    setNameFromChildByTag(ret, 'id');
    if (ret.children.length == 0) {
        ret.isText = true;
        ret.textified = ret.name;
    }
    else {
        // remains `initU child
        console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
        if (isChildrenCount(ret, 1)) {
            if (ret.children[0].textified) {
                var c1 = ret.children[0].textified;
                ret.name = ret.name + ' = ' + c1;
                // TODO This is ok for VariableDeclaration/VariableDeclarator
                // But could have collaterals ?
                ret.textified = ret.name;
            }
            if (ret.children[0].isText) {
                var c1 = ret.children[0].name;
                ret.name = ret.name + ' = ' + c1;
                ret.isText = true;
                ret.textified = ret.name;
                ret.children = [];
            }
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.Decorator = function(parent, node, options) {
    console.log('node Decorator -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property expression and append ittfNode to `ret`
    if (node.expression) {
        if (!node.expression.type) {
            throw 'Node expression has no type';
        }
        format(ret, node.expression, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.Directive = function(parent, node, options) {
    console.log('node Directive -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property value and append ittfNode to `ret`
    if (node.value) {
        if (!node.value.type) {
            throw 'Node value has no type';
        }
        format(ret, node.value, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.DirectiveLiteral = function(parent, node, options) {
    console.log('node DirectiveLiteral -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.Expression = function(parent, node, options) {
    console.log('node Expression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Any expression node. Since the left-hand side of an assignment may be any expression in general, an expression can also be a pattern.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.Super = function(parent, node, options) {
    console.log('node Super -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'super', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `super` pseudo-expression.
    ret.name = 'super';
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.Import = function(parent, node, options) {
    console.log('node Import -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'import', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `import` pseudo-expression.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ThisExpression = function(parent, node, options) {
    console.log('node ThisExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'this', 
        name: '', 
        isText: true, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `this` expression.
    ret.name = 'this';
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ArrowFunctionExpression = function(parent, node, options) {
    console.log('node ArrowFunctionExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '=>', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.body) {
        var count = 0, temp;
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > BlockStatement | Expression) {
                    break;
                }
            */
        }
    }
    console.log('node.expression', node.expression);
    if (!!node.expression == true) {
        ret.children.push({
            tag: 'expression', 
            children: [
                
            ]
        });
    }
    // A fat arrow function expression, e.g., `let foo = (bar) => { /* body */ }`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.YieldExpression = function(parent, node, options) {
    console.log('node YieldExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'yeld', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_argument = {
        children: [
            
        ]
    };
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(p_argument, node.argument, options);
        p_argument.tag = 'argument';
        ret.children.push(p_argument);
        if (p_argument.children.length == 1) {
            if (p_argument.children[0].textified) {
                p_argument.textified = p_argument.children[0].textified;
            }
            if (p_argument.children[0].isText) {
                p_argument.isText = true;
                p_argument.name = p_argument.children[0].name;
                p_argument.children = [];
                console.log('*** f_p_tag', 'argument', p_argument.children.length, p_argument.children.length == 1 && p_argument.children[0].isText, ret);
            }
        }
    }
    console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
    if (isChildrenCount(ret, 1)) {
        if (ret.children[0].textified) {
            var c1 = ret.children[0].textified;
            ret.name = c1;
            // TODO This is ok for VariableDeclaration/VariableDeclarator
            // But could have collaterals ?
            ret.textified = ret.name;
        }
        if (ret.children[0].isText) {
            var c1 = ret.children[0].name;
            ret.name = c1;
            ret.isText = true;
            ret.textified = ret.name;
            ret.children = [];
        }
    }
    console.log('node.delegate', node.delegate);
    if (!!node.delegate == true) {
        ret.children.push({
            tag: 'delegate', 
            children: [
                
            ]
        });
    }
    // A `yield` expression.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.AwaitExpression = function(parent, node, options) {
    console.log('node AwaitExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'await', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(ret, node.argument, options);
    }
    // A `await` expression.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ArrayExpression = function(parent, node, options) {
    console.log('node ArrayExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '[', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.elements) {
        var count = 0, temp;
        var i, i_items=node.elements, i_len=node.elements.length, item;
        for (i=0; i<i_len; i++) {
            item = node.elements[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // An array expression.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ObjectExpression = function(parent, node, options) {
    console.log('node ObjectExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '{', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.properties) {
        var count = 0, temp;
        var i, i_items=node.properties, i_len=node.properties.length, item;
        for (i=0; i<i_len; i++) {
            item = node.properties[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // An object expression.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ObjectProperty = function(parent, node, options) {
    console.log('node ObjectProperty -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '@ ' + objectDeclareKey(node.key.name || node.key.value), 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // f_p_tag( key, key, Expression
    // process node property value and append ittfNode to `ret`
    if (node.value) {
        if (!node.value.type) {
            throw 'Node value has no type';
        }
        format(ret, node.value, options);
    }
    // b( computed
    // b( shorthand
    if (node.decorators) {
        var count = 0, temp;
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ObjectMethod = function(parent, node, options) {
    console.log('node ObjectMethod -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // s( kind
    // enum "get" | "set" | "method"
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.FunctionExpression = function(parent, node, options) {
    console.log('node FunctionExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'function', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A `function` expression.
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type';
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // Embed an array of nodes in a new tag
    if (node.params && node.params.length > 0) {
        var tempparams = {
            tag: 'params', 
            children: [
                
            ]
        };
        var i, i_items=node.params, i_len=node.params.length, item;
        for (i=0; i<i_len; i++) {
            item = node.params[i];
            format(tempparams, item, options);
        }
        ret.children.push(tempparams);
    }
    // [ Pattern ]
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    console.log('node.generator', node.generator);
    if (!!node.generator == true) {
        ret.children.push({
            tag: 'generator', 
            children: [
                
            ]
        });
    }
    // Creates a tag node from an attribute property, when not null
    if (node.async) {
        var tempasync = {
            tag: 'async', 
            children: [
                
            ]
        };
        tempasync.name = node.async;
    }
    replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param');
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.UnaryExpression = function(parent, node, options) {
    console.log('node UnaryExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'op ' + node.operator, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A unary operator expression.
    // s( operator, UnaryOperator enum "-" | "+" | "!" | "~" | "typeof" | "void" | "delete" | "throw"
    console.log('node.prefix', node.prefix);
    if (!!node.prefix == true) {
        ret.children.push({
            tag: 'prefix', 
            children: [
                
            ]
        });
    }
    var p_argument = {
        children: [
            
        ]
    };
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(p_argument, node.argument, options);
        p_argument.tag = 'argument';
        ret.children.push(p_argument);
        if (p_argument.children.length == 1) {
            if (p_argument.children[0].textified) {
                p_argument.textified = p_argument.children[0].textified;
            }
            if (p_argument.children[0].isText) {
                p_argument.isText = true;
                p_argument.name = p_argument.children[0].name;
                p_argument.children = [];
                console.log('*** f_p_tag', 'argument', p_argument.children.length, p_argument.children.length == 1 && p_argument.children[0].isText, ret);
            }
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.UpdateExpression = function(parent, node, options) {
    console.log('node UpdateExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'op ' + node.operator, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An update (increment or decrement) operator expression.
    // s( operator, UpdateOperator enum "++" | "--"
    var p_argument = {
        children: [
            
        ]
    };
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(p_argument, node.argument, options);
        p_argument.tag = 'argument';
        ret.children.push(p_argument);
        if (p_argument.children.length == 1) {
            if (p_argument.children[0].textified) {
                p_argument.textified = p_argument.children[0].textified;
            }
            if (p_argument.children[0].isText) {
                p_argument.isText = true;
                p_argument.name = p_argument.children[0].name;
                p_argument.children = [];
                console.log('*** f_p_tag', 'argument', p_argument.children.length, p_argument.children.length == 1 && p_argument.children[0].isText, ret);
            }
        }
    }
    console.log('node.prefix', node.prefix);
    if (!!node.prefix == true) {
        ret.children.push({
            tag: 'prefix', 
            children: [
                
            ]
        });
    }
    if (node.prefix) {
        console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
        if (isChildrenCount(ret, 1)) {
            if (ret.children[0].textified) {
                var c1 = ret.children[0].textified;
                ret.name = node.operator + c1;
                // TODO This is ok for VariableDeclaration/VariableDeclarator
                // But could have collaterals ?
                ret.textified = ret.name;
            }
            if (ret.children[0].isText) {
                var c1 = ret.children[0].name;
                ret.name = node.operator + c1;
                ret.isText = true;
                ret.textified = ret.name;
                ret.children = [];
            }
        }
    }
    else {
        console.log('get_text_from_1_children', isChildrenCount(ret, 1), ret);
        if (isChildrenCount(ret, 1)) {
            if (ret.children[0].textified) {
                var c1 = ret.children[0].textified;
                ret.name = c1 + node.operator;
                // TODO This is ok for VariableDeclaration/VariableDeclarator
                // But could have collaterals ?
                ret.textified = ret.name;
            }
            if (ret.children[0].isText) {
                var c1 = ret.children[0].name;
                ret.name = c1 + node.operator;
                ret.isText = true;
                ret.textified = ret.name;
                ret.children = [];
            }
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.BinaryExpression = function(parent, node, options) {
    console.log('node BinaryExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'op ' + node.operator, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A binary operator token.
    // s( operator, BinaryOperator
    // enum "==" | "!=" | "===" | "!==" "<" | "<=" | ">" | ">=" | "<<" | ">>" | ">>>" | "+" | "-" | "*" | "/" | "%" | "|" | "^" | "&" | "in" | "instanceof" | "|>"
    // process node property left and append ittfNode to `ret`
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type';
        }
        format(ret, node.left, options);
    }
    // process node property right and append ittfNode to `ret`
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type';
        }
        format(ret, node.right, options);
    }
    if (isChildrenCount(ret, 2)) {
        if (ret.children[0].textified && ret.children[1].textified) {
            var c1 = ret.children[0].textified;
            var c2 = ret.children[1].textified;
            ret.name = c1 + ' ' + node.operator + ' ' + c2;
        }
        if (ret.children[0].isText && ret.children[1].isText) {
            var c1 = ret.children[0].name;
            var c2 = ret.children[1].name;
            ret.name = c1 + ' ' + node.operator + ' ' + c2;
            ret.isText = true;
            ret.children = [];
            ret.tag = 'op';
        }
    }
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.AssignmentExpression = function(parent, node, options) {
    console.log('node AssignmentExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'set ' + node.operator, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // An assignment operator expression.
    // s( operator, AssignmentOperator
    // enum AssignmentOperator { "=" | "+=" | "-=" | "*=" | "/=" | "%=" | "<<=" | ">>=" | ">>>=" | "|=" | "^=" | "&="
    // process node property left and append ittfNode to `ret`
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type';
        }
        format(ret, node.left, options);
    }
    // process node property right and append ittfNode to `ret`
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type';
        }
        format(ret, node.right, options);
    }
    if (isChildrenCount(ret, 2)) {
        if (ret.children[0].textified && ret.children[1].textified) {
            var c1 = ret.children[0].textified;
            var c2 = ret.children[1].textified;
            ret.name = c1 + ' ' + node.operator + ' ' + c2;
        }
        if (ret.children[0].isText && ret.children[1].isText) {
            var c1 = ret.children[0].name;
            var c2 = ret.children[1].name;
            ret.name = c1 + ' ' + node.operator + ' ' + c2;
            ret.isText = true;
            ret.children = [];
            ret.tag = 'set';
        }
    }
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.LogicalExpression = function(parent, node, options) {
    console.log('node LogicalExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'op ' + node.operator, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A logical operator expression.
    // s( operator, LogicalOperator enum "||" | "&&" | "??"
    // process node property left and append ittfNode to `ret`
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type';
        }
        format(ret, node.left, options);
    }
    // process node property right and append ittfNode to `ret`
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type';
        }
        format(ret, node.right, options);
    }
    if (isChildrenCount(ret, 2)) {
        if (ret.children[0].textified && ret.children[1].textified) {
            var c1 = ret.children[0].textified;
            var c2 = ret.children[1].textified;
            ret.name = c1 + ' ' + node.operator + ' ' + c2;
        }
        if (ret.children[0].isText && ret.children[1].isText) {
            var c1 = ret.children[0].name;
            var c2 = ret.children[1].name;
            ret.name = c1 + ' ' + node.operator + ' ' + c2;
            ret.isText = true;
            ret.children = [];
            ret.tag = 'op';
        }
    }
    ret.textified = ret.name;
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.SpreadElement = function(parent, node, options) {
    console.log('node SpreadElement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '...', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(ret, node.argument, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.MemberExpression = function(parent, node, options) {
    console.log('node MemberExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'expr', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_object = {
        children: [
            
        ]
    };
    if (node.object) {
        if (!node.object.type) {
            throw 'Node object has no type';
        }
        format(p_object, node.object, options);
        p_object.tag = 'object';
        ret.children.push(p_object);
        if (p_object.children.length == 1) {
            if (p_object.children[0].textified) {
                p_object.textified = p_object.children[0].textified;
            }
            if (p_object.children[0].isText) {
                p_object.isText = true;
                p_object.name = p_object.children[0].name;
                p_object.children = [];
                console.log('*** f_p_tag', 'object', p_object.children.length, p_object.children.length == 1 && p_object.children[0].isText, ret);
            }
        }
    }
    var p_property = {
        children: [
            
        ]
    };
    if (node.property) {
        if (!node.property.type) {
            throw 'Node property has no type';
        }
        format(p_property, node.property, options);
        p_property.tag = 'property';
        ret.children.push(p_property);
        if (p_property.children.length == 1) {
            if (p_property.children[0].textified) {
                p_property.textified = p_property.children[0].textified;
            }
            if (p_property.children[0].isText) {
                p_property.isText = true;
                p_property.name = p_property.children[0].name;
                p_property.children = [];
                console.log('*** f_p_tag', 'property', p_property.children.length, p_property.children.length == 1 && p_property.children[0].isText, ret);
            }
        }
    }
    // b( computed
    // b( optional, optional
    // A member expression.
    // If `computed` is `true`, the node corresponds to a computed (`a[b]`) member expression and `property` is an `Expression`.
    // If `computed` is `false`, the node corresponds to a static (`a.b`) member expression and `property` is an `Identifier`.
    // The `optional` flags indicates that the member expression can be called even if the object is null or undefined.
    // If this is the object value (null/undefined) should be returned.
    console.log('*** MemberExpression', ret.children[0].isText, ret.children[1].isText);
    if (ret.children[0].isText && ret.children[1].isText) {
        var obj = ret.children[0].name;
        var prop = ret.children[1].name;
        ret.name = node.computed ? obj + '[' + prop + ']' : obj + '.' + prop;
        ret.isText = true;
        ret.children = [];
        ret.textified = ret.name;
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.BindExpression = function(parent, node, options) {
    console.log('node BindExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property object and append ittfNode to `ret`
    if (node.object) {
        if (!node.object.type) {
            throw 'Node object has no type';
        }
        format(ret, node.object, options);
    }
    // process node property callee and append ittfNode to `ret`
    if (node.callee) {
        if (!node.callee.type) {
            throw 'Node callee has no type';
        }
        format(ret, node.callee, options);
    }
    // if `object` is `null`, then `callee` should be a `MemberExpression`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ConditionalExpression = function(parent, node, options) {
    console.log('node ConditionalExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'iif', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A conditional expression, i.e., a ternary `?`/`,` expression.
    var p_test = {
        children: [
            
        ]
    };
    if (node.test) {
        if (!node.test.type) {
            throw 'Node test has no type';
        }
        format(p_test, node.test, options);
        p_test.tag = 'test';
        ret.children.push(p_test);
        if (p_test.children.length == 1) {
            if (p_test.children[0].textified) {
                p_test.textified = p_test.children[0].textified;
            }
            if (p_test.children[0].isText) {
                p_test.isText = true;
                p_test.name = p_test.children[0].name;
                p_test.children = [];
                console.log('*** f_p_tag', 'test', p_test.children.length, p_test.children.length == 1 && p_test.children[0].isText, ret);
            }
        }
    }
    var p_consequent = {
        children: [
            
        ]
    };
    if (node.consequent) {
        if (!node.consequent.type) {
            throw 'Node consequent has no type';
        }
        format(p_consequent, node.consequent, options);
        p_consequent.tag = 'then';
        ret.children.push(p_consequent);
        if (p_consequent.children.length == 1) {
            if (p_consequent.children[0].textified) {
                p_consequent.textified = p_consequent.children[0].textified;
            }
            if (p_consequent.children[0].isText) {
                p_consequent.isText = true;
                p_consequent.name = p_consequent.children[0].name;
                p_consequent.children = [];
                console.log('*** f_p_tag', 'consequent', p_consequent.children.length, p_consequent.children.length == 1 && p_consequent.children[0].isText, ret);
            }
        }
    }
    var p_alternate = {
        children: [
            
        ]
    };
    if (node.alternate) {
        if (!node.alternate.type) {
            throw 'Node alternate has no type';
        }
        format(p_alternate, node.alternate, options);
        p_alternate.tag = 'else';
        ret.children.push(p_alternate);
        if (p_alternate.children.length == 1) {
            if (p_alternate.children[0].textified) {
                p_alternate.textified = p_alternate.children[0].textified;
            }
            if (p_alternate.children[0].isText) {
                p_alternate.isText = true;
                p_alternate.name = p_alternate.children[0].name;
                p_alternate.children = [];
                console.log('*** f_p_tag', 'alternate', p_alternate.children.length, p_alternate.children.length == 1 && p_alternate.children[0].isText, ret);
            }
        }
    }
    setNameFromChildByTag(ret, 'test', true);
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.CallExpression = function(parent, node, options) {
    console.log('node CallExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '_', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A function or method call expression.
    var p_callee = {
        children: [
            
        ]
    };
    if (node.callee) {
        if (!node.callee.type) {
            throw 'Node callee has no type';
        }
        format(p_callee, node.callee, options);
        p_callee.tag = 'callee';
        ret.children.push(p_callee);
        if (p_callee.children.length == 1) {
            if (p_callee.children[0].textified) {
                p_callee.textified = p_callee.children[0].textified;
            }
            if (p_callee.children[0].isText) {
                p_callee.isText = true;
                p_callee.name = p_callee.children[0].name;
                p_callee.children = [];
                console.log('*** f_p_tag', 'callee', p_callee.children.length, p_callee.children.length == 1 && p_callee.children[0].isText, ret);
            }
        }
    }
    // Embed an array of nodes in a new tag
    if (node.arguments && node.arguments.length > 0) {
        var temparguments = {
            tag: 'arguments', 
            children: [
                
            ]
        };
        var i, i_items=node.arguments, i_len=node.arguments.length, item;
        for (i=0; i<i_len; i++) {
            item = node.arguments[i];
            format(temparguments, item, options);
        }
        ret.children.push(temparguments);
    }
    // first of all try to set ret.textified
    var calleeNode = getChildByTag(ret, 'callee');
    var argumentsNode = getChildByTag(ret, 'arguments');
    if (calleeNode && calleeNode.isText) {
        if (argumentsNode) {
            var tlist = getTextList(argumentsNode, ',');
            if (tlist) {
                ret.textified = calleeNode.name + '(' + tlist + ')';
            }
        }
        else {
            ret.textified = calleeNode.name + '()';
        }
    }
    if (ret.children[0].isText) {
        ret.name = ret.children[0].name;
        ret.children.splice(0,1);
    }
    replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'arguments'), '@');
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.NewExpression = function(parent, node, options) {
    console.log('node NewExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'new', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Embed an array of nodes in a new tag
    if (node.arguments && node.arguments.length > 0) {
        var temparguments = {
            tag: '2', 
            children: [
                
            ]
        };
        var i, i_items=node.arguments, i_len=node.arguments.length, item;
        for (i=0; i<i_len; i++) {
            item = node.arguments[i];
            format(temparguments, item, options);
        }
        ret.children.push(temparguments);
    }
    var p_callee = {
        children: [
            
        ]
    };
    if (node.callee) {
        if (!node.callee.type) {
            throw 'Node callee has no type';
        }
        format(p_callee, node.callee, options);
        p_callee.tag = 'callee';
        ret.children.push(p_callee);
        if (p_callee.children.length == 1) {
            if (p_callee.children[0].textified) {
                p_callee.textified = p_callee.children[0].textified;
            }
            if (p_callee.children[0].isText) {
                p_callee.isText = true;
                p_callee.name = p_callee.children[0].name;
                p_callee.children = [];
                console.log('*** f_p_tag', 'callee', p_callee.children.length, p_callee.children.length == 1 && p_callee.children[0].isText, ret);
            }
        }
    }
    setTextList(ret.children[0], ', ');
    if (isChildrenCount(ret, 2)) {
        if (ret.children[0].textified && ret.children[1].textified) {
            var c1 = ret.children[0].textified;
            var c2 = ret.children[1].textified;
            ret.name = 'new ' + c2 + '(' + c1 + ")";
        }
        if (ret.children[0].isText && ret.children[1].isText) {
            var c1 = ret.children[0].name;
            var c2 = ret.children[1].name;
            ret.name = 'new ' + c2 + '(' + c1 + ")";
            ret.isText = true;
            ret.children = [];
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.SequenceExpression = function(parent, node, options) {
    console.log('node SequenceExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.expressions) {
        var count = 0, temp;
        var i, i_items=node.expressions, i_len=node.expressions.length, item;
        for (i=0; i<i_len; i++) {
            item = node.expressions[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // A sequence expression, i.e., a comma-separated sequence of expressions.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.DoExpression = function(parent, node, options) {
    console.log('node DoExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.TemplateLiteral = function(parent, node, options) {
    console.log('node TemplateLiteral -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.quasis) {
        var count = 0, temp;
        var i, i_items=node.quasis, i_len=node.quasis.length, item;
        for (i=0; i<i_len; i++) {
            item = node.quasis[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    if (node.expressions) {
        var count = 0, temp;
        var i, i_items=node.expressions, i_len=node.expressions.length, item;
        for (i=0; i<i_len; i++) {
            item = node.expressions[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.TaggedTemplateExpression = function(parent, node, options) {
    console.log('node TaggedTemplateExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property tag and append ittfNode to `ret`
    if (node.tag) {
        if (!node.tag.type) {
            throw 'Node tag has no type';
        }
        format(ret, node.tag, options);
    }
    // process node property quasi and append ittfNode to `ret`
    if (node.quasi) {
        if (!node.quasi.type) {
            throw 'Node quasi has no type';
        }
        format(ret, node.quasi, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.TemplateElement = function(parent, node, options) {
    console.log('node TemplateElement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    console.log('node.tail', node.tail);
    if (!!node.tail == true) {
        ret.children.push({
            tag: 'tail', 
            children: [
                
            ]
        });
    }
    // process node property value and append ittfNode to `ret`
    if (node.value) {
        if (!node.value.type) {
            throw 'Node value has no type';
        }
        format(ret, node.value, options);
    }
    // f_p_p( value, cooked, optional
    // f_p_p( value, raw
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ObjectPattern = function(parent, node, options) {
    console.log('node ObjectPattern -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property value and append ittfNode to `ret`
    if (node.value) {
        if (!node.value.type) {
            throw 'Node value has no type';
        }
        format(ret, node.value, options);
    }
    if (node.properties) {
        var count = 0, temp;
        var i, i_items=node.properties, i_len=node.properties.length, item;
        for (i=0; i<i_len; i++) {
            item = node.properties[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ArrayPattern = function(parent, node, options) {
    console.log('node ArrayPattern -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.elements) {
        var count = 0, temp;
        var i, i_items=node.elements, i_len=node.elements.length, item;
        for (i=0; i<i_len; i++) {
            item = node.elements[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.RestElement = function(parent, node, options) {
    console.log('node RestElement -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '...', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property argument and append ittfNode to `ret`
    if (node.argument) {
        if (!node.argument.type) {
            throw 'Node argument has no type';
        }
        format(ret, node.argument, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.AssignmentPattern = function(parent, node, options) {
    console.log('node AssignmentPattern -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property left and append ittfNode to `ret`
    if (node.left) {
        if (!node.left.type) {
            throw 'Node left has no type';
        }
        format(ret, node.left, options);
    }
    // process node property right and append ittfNode to `ret`
    if (node.right) {
        if (!node.right.type) {
            throw 'Node right has no type';
        }
        format(ret, node.right, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.Class = function(parent, node, options) {
    console.log('node Class -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'class', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type';
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // process node property superClass and append ittfNode to `ret`
    if (node.superClass) {
        if (!node.superClass.type) {
            throw 'Node superClass has no type';
        }
        format(ret, node.superClass, options);
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (node.decorators) {
        var count = 0, temp;
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ClassBody = function(parent, node, options) {
    console.log('node ClassBody -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = parent;
    if (node.body) {
        var count = 0, temp;
        var i, i_items=node.body, i_len=node.body.length, item;
        for (i=0; i<i_len; i++) {
            item = node.body[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
};
format.ClassMethod = function(parent, node, options) {
    console.log('node ClassMethod -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    var p_key = {
        children: [
            
        ]
    };
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type';
        }
        format(p_key, node.key, options);
        p_key.tag = 'key';
        ret.children.push(p_key);
        if (p_key.children.length == 1) {
            if (p_key.children[0].textified) {
                p_key.textified = p_key.children[0].textified;
            }
            if (p_key.children[0].isText) {
                p_key.isText = true;
                p_key.name = p_key.children[0].name;
                p_key.children = [];
                console.log('*** f_p_tag', 'key', p_key.children.length, p_key.children.length == 1 && p_key.children[0].isText, ret);
            }
        }
    }
    // s( kind
    // enum "constructor" | "method" | "get" | "set"
    console.log('node.computed', node.computed);
    if (!!node.computed == true) {
        ret.children.push({
            tag: 'computed', 
            children: [
                
            ]
        });
    }
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    console.log('node.generator', node.generator);
    if (!!node.generator == true) {
        ret.children.push({
            tag: 'generator', 
            children: [
                
            ]
        });
    }
    console.log('node.async', node.async);
    if (!!node.async == true) {
        ret.children.push({
            tag: 'async', 
            children: [
                
            ]
        });
    }
    if (node.decorators) {
        var count = 0, temp;
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // Embed an array of nodes in a new tag
    if (node.params && node.params.length > 0) {
        var tempparams = {
            tag: 'params', 
            children: [
                
            ]
        };
        var i, i_items=node.params, i_len=node.params.length, item;
        for (i=0; i<i_len; i++) {
            item = node.params[i];
            format(tempparams, item, options);
        }
        ret.children.push(tempparams);
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    ret.tag = ret.tag == 'constructor' ? 'ctor' : (ret.tag == 'method' ? 'm' : ret.tag);
    setNameFromChildByTag(ret, 'key');
    replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param');
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ClassPrivateMethod = function(parent, node, options) {
    console.log('node ClassPrivateMethod -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: node.kind, 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property key and append ittfNode to `ret`
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type';
        }
        format(ret, node.key, options);
    }
    // s( kind, "method" | "get" | "set"
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    if (node.decorators) {
        var count = 0, temp;
        var i, i_items=node.decorators, i_len=node.decorators.length, item;
        for (i=0; i<i_len; i++) {
            item = node.decorators[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // Embed an array of nodes in a new tag
    if (node.params && node.params.length > 0) {
        var tempparams = {
            tag: 'params', 
            children: [
                
            ]
        };
        var i, i_items=node.params, i_len=node.params.length, item;
        for (i=0; i<i_len; i++) {
            item = node.params[i];
            format(tempparams, item, options);
        }
        ret.children.push(tempparams);
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    ret.tag = ret.tag == 'method' ? 'm' : ret.tag;
    replaceChildrenOfChildWhenText(ret, getChildPosByTag(ret, 'params'), 'param');
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ClassProperty = function(parent, node, options) {
    console.log('node ClassProperty -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property key and append ittfNode to `ret`
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type';
        }
        format(ret, node.key, options);
    }
    // process node property value and append ittfNode to `ret`
    if (node.value) {
        if (!node.value.type) {
            throw 'Node value has no type';
        }
        format(ret, node.value, options);
    }
    // b( computed
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ClassPrivateProperty = function(parent, node, options) {
    console.log('node ClassPrivateProperty -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property key and append ittfNode to `ret`
    if (node.key) {
        if (!node.key.type) {
            throw 'Node key has no type';
        }
        format(ret, node.key, options);
    }
    // process node property value and append ittfNode to `ret`
    if (node.value) {
        if (!node.value.type) {
            throw 'Node value has no type';
        }
        format(ret, node.value, options);
    }
    console.log('node.static', node.static);
    if (!!node.static == true) {
        ret.children.push({
            tag: 'static', 
            children: [
                
            ]
        });
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ClassDeclaration = function(parent, node, options) {
    console.log('node ClassDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'class', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type';
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    var p_superClass = {
        children: [
            
        ]
    };
    if (node.superClass) {
        if (!node.superClass.type) {
            throw 'Node superClass has no type';
        }
        format(p_superClass, node.superClass, options);
        p_superClass.tag = 'super';
        ret.children.push(p_superClass);
        if (p_superClass.children.length == 1) {
            if (p_superClass.children[0].textified) {
                p_superClass.textified = p_superClass.children[0].textified;
            }
            if (p_superClass.children[0].isText) {
                p_superClass.isText = true;
                p_superClass.name = p_superClass.children[0].name;
                p_superClass.children = [];
                console.log('*** f_p_tag', 'superClass', p_superClass.children.length, p_superClass.children.length == 1 && p_superClass.children[0].isText, ret);
            }
        }
    }
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ClassExpression = function(parent, node, options) {
    console.log('node ClassExpression -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property body and append ittfNode to `ret`
    if (node.body) {
        if (!node.body.type) {
            throw 'Node body has no type';
        }
        format(ret, node.body, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.MetaProperty = function(parent, node, options) {
    console.log('node MetaProperty -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.meta) {
        if (!node.meta.type) {
            throw 'Node meta has no type';
        }
        var tempmeta = {
            children: [
                
            ]
        };
        format(tempmeta, node.meta, options);
        /**
            if (tempmeta .children.length > 0) {
                throw 'node.meta must result zero node, returned: ' + tempmeta.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempmeta.children.length > 0) {
            appto.name = tempmeta.children[0].name;
        }
        else {
            appto.name = tempmeta.name;
        }
    }
    // process node property property and append ittfNode to `ret`
    if (node.property) {
        if (!node.property.type) {
            throw 'Node property has no type';
        }
        format(ret, node.property, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ModuleDeclaration = function(parent, node, options) {
    console.log('node ModuleDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // A module `import` or `export` declaration.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ImportDeclaration = function(parent, node, options) {
    console.log('node ImportDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'import', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (node.specifiers) {
        var count = 0, temp;
        var i, i_items=node.specifiers, i_len=node.specifiers.length, item;
        for (i=0; i<i_len; i++) {
            item = node.specifiers[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    var p_source = {
        children: [
            
        ]
    };
    if (node.source) {
        if (!node.source.type) {
            throw 'Node source has no type';
        }
        format(p_source, node.source, options);
        p_source.tag = 'from';
        ret.children.push(p_source);
        if (p_source.children.length == 1) {
            if (p_source.children[0].textified) {
                p_source.textified = p_source.children[0].textified;
            }
            if (p_source.children[0].isText) {
                p_source.isText = true;
                p_source.name = p_source.children[0].name;
                p_source.children = [];
                console.log('*** f_p_tag', 'source', p_source.children.length, p_source.children.length == 1 && p_source.children[0].isText, ret);
            }
        }
    }
    // An import declaration, e.g., `import foo from "mod"`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ImportSpecifier = function(parent, node, options) {
    console.log('node ImportSpecifier -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '@', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.imported) {
        if (!node.imported.type) {
            throw 'Node imported has no type';
        }
        var tempimported = {
            children: [
                
            ]
        };
        format(tempimported, node.imported, options);
        /**
            if (tempimported .children.length > 0) {
                throw 'node.imported must result zero node, returned: ' + tempimported.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempimported.children.length > 0) {
            appto.name = tempimported.children[0].name;
        }
        else {
            appto.name = tempimported.name;
        }
    }
    // f_p( local, Identifier
    // An imported variable binding, e.g., `{foo}` in `import {foo} from "mod"` or `{foo as bar}` in `import {foo as bar} from "mod"`. The `imported` field refers to the name of the export imported from the module. The `local` field refers to the binding imported into the local module scope. If it is a basic named import, such as in `import {foo} from "mod"`, both `imported` and `local` are equivalent `Identifier` nodes in this case an `Identifier` node representing `foo`. If it is an aliased import, such as in `import {foo as bar} from "mod"`, the `imported` field is an `Identifier` node representing `foo`, and the `local` field is an `Identifier` node representing `bar`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ImportDefaultSpecifier = function(parent, node, options) {
    console.log('node ImportDefaultSpecifier -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'default', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.local) {
        if (!node.local.type) {
            throw 'Node local has no type';
        }
        var templocal = {
            children: [
                
            ]
        };
        format(templocal, node.local, options);
        /**
            if (templocal .children.length > 0) {
                throw 'node.local must result zero node, returned: ' + templocal.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (templocal.children.length > 0) {
            appto.name = templocal.children[0].name;
        }
        else {
            appto.name = templocal.name;
        }
    }
    // A default import specifier, e.g., `foo` in `import foo from "mod.js"`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ImportNamespaceSpecifier = function(parent, node, options) {
    console.log('node ImportNamespaceSpecifier -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'as', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property local and append ittfNode to `ret`
    if (node.local) {
        if (!node.local.type) {
            throw 'Node local has no type';
        }
        format(ret, node.local, options);
    }
    // A namespace import specifier, e.g., `* as foo` in `import * as foo from "mod.js"`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ExportNamedDeclaration = function(parent, node, options) {
    console.log('node ExportNamedDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property declaration and append ittfNode to `ret`
    if (node.declaration) {
        if (!node.declaration.type) {
            throw 'Node declaration has no type';
        }
        format(ret, node.declaration, options);
    }
    if (node.specifiers) {
        var count = 0, temp;
        var i, i_items=node.specifiers, i_len=node.specifiers.length, item;
        for (i=0; i<i_len; i++) {
            item = node.specifiers[i];
            format(ret, item, options);
            count ++;
            /**
                if (count > 2) {
                    break;
                }
            */
        }
    }
    // process node property source and append ittfNode to `ret`
    if (node.source) {
        if (!node.source.type) {
            throw 'Node source has no type';
        }
        format(ret, node.source, options);
    }
    // An export named declaration, e.g., `export {foo, bar}`, `export {foo} from "mod"`, `export var foo = 1` or `export * as foo from "bar"`.
    // _Note, Having `declaration` populated with non-empty `specifiers` or non-null `source` results in an invalid state._
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ExportSpecifier = function(parent, node, options) {
    console.log('node ExportSpecifier -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '@', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.exported) {
        if (!node.exported.type) {
            throw 'Node exported has no type';
        }
        var tempexported = {
            children: [
                
            ]
        };
        format(tempexported, node.exported, options);
        /**
            if (tempexported .children.length > 0) {
                throw 'node.exported must result zero node, returned: ' + tempexported.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempexported.children.length > 0) {
            appto.name = tempexported.children[0].name;
        }
        else {
            appto.name = tempexported.name;
        }
    }
    // process node property local and append ittfNode to `ret`
    if (node.local) {
        if (!node.local.type) {
            throw 'Node local has no type';
        }
        format(ret, node.local, options);
    }
    // An exported variable binding, e.g., `{foo}` in `export {foo}` or `{bar as foo}` in `export {bar as foo}`. The `exported` field refers to the name exported in the module. The `local` field refers to the binding into the local module scope. If it is a basic named export, such as in `export {foo}`, both `exported` and `local` are equivalent `Identifier` nodes in this case an `Identifier` node representing `foo`. If it is an aliased export, such as in `export {bar as foo}`, the `exported` field is an `Identifier` node representing `foo`, and the `local` field is an `Identifier` node representing `bar`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ExportDefaultDeclaration = function(parent, node, options) {
    console.log('node ExportDefaultDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'none', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // Format node property &&
    // and set the resulting node.name on : ret || parent (cmd: onparent)
    // used mainly for Identifier(s)
    if (node.id) {
        if (!node.id.type) {
            throw 'Node id has no type';
        }
        var tempid = {
            children: [
                
            ]
        };
        format(tempid, node.id, options);
        /**
            if (tempid .children.length > 0) {
                throw 'node.id must result zero node, returned: ' + tempid.children.length + ' source: ' + options.input.substring(node.start, node.end);
            }
        */
        var appto = false ? parent : ret;
        if (tempid.children.length > 0) {
            appto.name = tempid.children[0].name;
        }
        else {
            appto.name = tempid.name;
        }
    }
    // process node property declaration and append ittfNode to `ret`
    if (node.declaration) {
        if (!node.declaration.type) {
            throw 'Node declaration has no type';
        }
        format(ret, node.declaration, options);
    }
    // An export default declaration, e.g., `export default function () {}` or `export default 1`.
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.ExportAllDeclaration = function(parent, node, options) {
    console.log('node ExportAllDeclaration -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: 'all', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    // process node property source and append ittfNode to `ret`
    if (node.source) {
        if (!node.source.type) {
            throw 'Node source has no type';
        }
        format(ret, node.source, options);
    }
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.CommentBlock = function(parent, node, options) {
    console.log('node CommentBlock -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '#', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
format.CommentLine = function(parent, node, options) {
    console.log('node CommentLine -----------------------------------------', parent);
    var i, i_items=Object.keys(node), i_len=Object.keys(node).length, item;
    for (i=0; i<i_len; i++) {
        item = Object.keys(node)[i];
        if (verify.isNotEmpty(node[item])) {
            console.log('property', item, node[item]);
        }
        else {
            console.log('property', item);
        }
    }
    var ret = {
        tag: '#', 
        name: '', 
        isText: false, 
        source: options.input.substring(node.start, node.end), 
        children: [
            
        ]
    };
    if (parent && parent.children) {
        parent.children.push(ret);
    }
};
var md = module.exports = {};
function removeChildByTag(ittfNode, tag) {
    var temp = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag !== tag) {
            temp.push(item);
        }
    }
    ittfNode.children = temp;
}
function getChildByTag(ittfNode, tag) {
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag === tag) {
            return item;
        }
    }
    return null;
}
function getChildPosByTag(ittfNode, tag) {
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag === tag) {
            return i;
        }
    }
    return -1;
}
function replaceChildrenOfChildWhenText(ittfNode, childPos, textTag) {
    if (childPos < 0) {
        return ;
    }
    ittfNode.children = replaceItemInColl(ittfNode.children, childPos, textifyChildren(ittfNode.children[childPos], textTag));
}
function replaceItemInColl(coll, pos, replacers) {
    var ret = [];
    var i, i_items=coll, i_len=coll.length, item;
    for (i=0; i<i_len; i++) {
        item = coll[i];
        if (pos == i) {
            var j, j_items=replacers, j_len=replacers.length, repl;
            for (j=0; j<j_len; j++) {
                repl = replacers[j];
                ret.push(repl);
            }
        }
        else {
            ret.push(item);
        }
    }
    return ret;
}
function textifyChildren(ittfNode, tag) {
    var ret = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.isText) {
            ret.push({
                tag: tag, 
                name: item.name, 
                children: [
                    
                ]
            });
        }
        else {
            ret.push(item);
        }
    }
    // log '@@@@@@@@@@@@@@@ textifyChildren', ret
    return ret;
}
function setTextList(ittfNode, sep) {
    var ret = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.isText) {
            ret.push(item.name);
        }
        else {
            return ;
        }
    }
    ittfNode.isText = true;
    ittfNode.name = ret.join(sep);
    ittfNode.children = [];
}
function getTextList(ittfNode, sep) {
    var ret = [];
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.isText) {
            ret.push(item.name);
        }
        else {
            console.log('getTextList failed ***************', item);
            return null;
        }
    }
    return ret.join(sep);
}
function setNameFromChildByTag(ittfNode, tag, forceText) {
    var i, i_items=ittfNode.children, i_len=ittfNode.children.length, item;
    for (i=0; i<i_len; i++) {
        item = ittfNode.children[i];
        if (item.tag === tag) {
            if (forceText) {
                console.log('...................setNameFromChildByTag', item);
            }
            if (item.isText) {
                ittfNode.name = item.name;
                ittfNode.children.splice(i, 1);
                return ;
            }
            if (forceText && item.textified) {
                ittfNode.name = item.textified;
                ittfNode.children.splice(i, 1);
                return ;
            }
        }
    }
}
function objectDeclareKey(key) {
    return key.indexOf(' ') > 0 ? '["' + key + '"]' : key;
}
function replaceWithSingleChild(ittfNode, childTag, limit) {
    if (isChildrenCount(ittfNode, 1)) {
        var childTag = ittfNode.children[0].tag;
        var testTag = limit ? childTag.substr(0, limit) : childTag;
        if (testTag === childTag) {
            ittfNode.tag = ittfNode.children[0].tag;
            ittfNode.name = ittfNode.children[0].name;
            ittfNode.children = ittfNode.children[0].children;
        }
    }
}
function isChildrenCount(ittfNode, count) {
    return ittfNode.children && ittfNode.children.length == count;
}
function isChildrenCountGreaterEqualThen(ittfNode, count) {
    return ittfNode.children && ittfNode.children.length >= count;
}
md.parse = function(input, options) {
    return parser.parse(input, {
            sourceType: 'module', 
            plugins: [
                "jsx", 
                "flow", 
                "objectRestSpread"
            ]
        });
};
md.getWizziIttf = function(input, options, callback) {
    console.log('options', options);
    options = options || {};
    options.input = input;
    options.stack = [];
    options.formatTextNodes = [];
    var startTime = Date.now();
    var babelOptions = options.babel || {};
    var syntax = md.parse(input, babelOptions);
    console.log('Parsed in ' + (Date.now() - startTime) + ' ms');
    options.starter = true;
    var root = {
        tag: 'module', 
        children: [
            
        ]
    };
    format(root, syntax, options);
    console.log("wizziTree", JSON.stringify(root, null, 2));
    var ittf = ittfwriter.stringify(root, { lang: 'js' });
    console.log("wizziIttf\n" + ittf);
    if (options.syntaxOutFile) {
        file.write(options.syntaxOutFile, JSON.stringify(cleanBabel.cleanAst(syntax), null, 2));
    }
    callback(null, ittf);
};
